"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
require("rxjs/add/operator/toPromise");
var moment = require("moment");
//Azteca Framework
var core_2 = require("framework3/core");
//Locales
var comprobante_fiscal_1 = require("../models/comprobante-fiscal");
var ComprobanteFiscalService = /** @class */ (function (_super) {
    __extends(ComprobanteFiscalService, _super);
    function ComprobanteFiscalService(http, context) {
        var _this = _super.call(this, http, context, 'api/contabilidad/comprobantes') || this;
        _this.http = http;
        _this.context = context;
        return _this;
    }
    ComprobanteFiscalService.prototype.create = function () {
        var newDoc = new comprobante_fiscal_1.ComprobanteFiscalInfo();
        return Promise.resolve(newDoc);
    };
    ComprobanteFiscalService.prototype.loadListAddendas = function (idEmpresa) {
        var params = new http_1.URLSearchParams();
        params.append("idEmpresa", idEmpresa.toString());
        return this.apiService.getData("load-list-addendas", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ComprobanteFiscalService.prototype.searchKeyword = function (idBranch, keyword, idContribuyente) {
        var params = new http_1.URLSearchParams();
        params.set("idBranch", idBranch.toString());
        params.set("keyword", keyword);
        params.set("idContribuyente", idContribuyente.toString());
        return this.apiService.getData("search-comprobantes", params)
            .map(function (response) { return response.json(); });
    };
    ComprobanteFiscalService.prototype.generarPdfTemporal = function (idComprobante) {
        var params = new http_1.URLSearchParams();
        params.set("idComprobanteFiscal", idComprobante);
        return this.apiService.getData("pdf-temporal", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ComprobanteFiscalService.prototype.getXml = function (idComprobanteFiscal) {
        var params = new http_1.URLSearchParams();
        params.set("idComprobanteFiscal", idComprobanteFiscal);
        return this.apiService.getData("xml", params)
            .map(function (response) { return response.text(); })
            .toPromise();
    };
    ComprobanteFiscalService.prototype.getXmlFile = function (idComprobanteFiscal) {
        var params = new http_1.URLSearchParams();
        params.set("idComprobanteFiscal", idComprobanteFiscal);
        return this.apiService.getData("xml-file", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ComprobanteFiscalService.prototype.cancelar = function (idComprobanteFiscal) {
        var params = new http_1.URLSearchParams();
        params.set("idComprobanteFiscal", idComprobanteFiscal);
        return this.apiService.getData("cancelar", params)
            .map(function (response) { return response.text(); })
            .toPromise();
    };
    ComprobanteFiscalService.prototype.timbrar = function (idComprobanteFiscal) {
        var params = new http_1.URLSearchParams();
        params.set("idComprobanteFiscal", idComprobanteFiscal);
        return this.apiService.getData("timbrar", params)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.enviar = function (idComprobanteFiscal, correo, mensaje) {
        var params = new http_1.URLSearchParams();
        params.set("idComprobanteFiscal", idComprobanteFiscal);
        params.set("correo", correo);
        params.set("mensaje", mensaje);
        return this.apiService.getData("send", params)
            .toPromise();
    };
    ComprobanteFiscalService.prototype.getEnvioFacturas = function (idEmpresa, fechaIni, fechaFin) {
        var params = new http_1.URLSearchParams();
        params.set("idEmpresa", idEmpresa.toString());
        params.set('fechaIni', moment(fechaIni).format());
        params.set('fechaFin', moment(fechaFin).format());
        return this.apiService.getData("envio-facturas-list", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ComprobanteFiscalService.prototype.ComprobantesDestinosList = function () {
        var params = new http_1.URLSearchParams();
        return this.apiService.getData("comprobantes-destino-list", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ComprobanteFiscalService.prototype.resetEnvioFacturas = function (idJob) {
        var params = new http_1.URLSearchParams();
        return this.apiService.postData('reset-envio-facturas', params, idJob)
            .toPromise();
    };
    //Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) en los resultados de búsquedas. Eliminar si no es necesario
    ComprobanteFiscalService.prototype.mapSearchResult = function (row) {
        row.fechaTimbrado = moment(row.fechaTimbrado).toDate();
    };
    //Descomentar si se necesita realizar conversión de fechas (o cualquier otro tipo de dato) al cargar un documento. Eliminar si no es necesario
    ComprobanteFiscalService.prototype.mapDocument = function (document) {
        document.fecha = moment(document.fecha).toDate();
        document.fechaAfectacion = moment(document.fechaAfectacion).toDate();
        document.timbreFiscal.fecha = moment(document.timbreFiscal.fecha).toDate();
    };
    //Portal de clientes
    ComprobanteFiscalService.prototype.portalClientes = function (idCliente, fechaIni, fechaFin) {
        var params = new http_1.URLSearchParams();
        params.set("idCliente", idCliente.toString());
        params.set('fechaIni', moment(fechaIni).format());
        params.set('fechaFin', moment(fechaFin).format());
        return this.apiService.getData("portal-clientes", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ComprobanteFiscalService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.Http, core_2.Context])
    ], ComprobanteFiscalService);
    return ComprobanteFiscalService;
}(core_2.DocumentService));
exports.ComprobanteFiscalService = ComprobanteFiscalService;
