"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
require("rxjs/add/operator/toPromise");
//Azteca Kernel
var core_2 = require("framework3/core");
var custom_1 = require("framework3/custom");
var ComprobanteService = /** @class */ (function (_super) {
    __extends(ComprobanteService, _super);
    function ComprobanteService(http, context) {
        return _super.call(this, http, context, "api/contabilidad/comprobante") || this;
    }
    ComprobanteService.prototype.getOptions = function () {
        var options = new custom_1.CatalogOptions();
        options.busquedasServidor = true;
        options.tamanioPagina = 10;
        return Promise.resolve(options);
    };
    ComprobanteService.prototype.uploadComprobante = function (cancelado, file) {
        var params = new http_1.URLSearchParams();
        params.set('cancelado', cancelado.toString());
        return this.apiService.postData('upload-comprobante', params, file).toPromise();
    };
    ComprobanteService.prototype.search = function (compania, fechaIni, fechaFin, tienePoliza, noTienePoliza, existeSiSatNoPixcua, existeNoSatSiPixcua, cancSiSatNoPixcua, cancNoSatSiPixcua, docEmitido, docRecibido, idBranch, request) {
        var params = new http_1.URLSearchParams();
        params.set('compania', compania);
        params.set('fechaIni', fechaIni);
        params.set('fechaFin', fechaFin);
        params.set('tienePoliza', tienePoliza.toString());
        params.set('noTienePoliza', noTienePoliza.toString());
        params.set('existeSiSatNoPixcua', existeSiSatNoPixcua.toString());
        params.set('existeNoSatSiPixcua', existeNoSatSiPixcua.toString());
        params.set('cancSiSatNoPixcua', cancSiSatNoPixcua.toString());
        params.set('cancNoSatSiPixcua', cancNoSatSiPixcua.toString());
        params.set('docEmitido', docEmitido.toString());
        params.set('docRecibido', docRecibido.toString());
        params.set('idBranch', idBranch.toString());
        return this.apiService.postData('search', params, request)
            .map(function (response) {
            return response.json();
        })
            .toPromise();
    };
    ComprobanteService.prototype.getComprobanteFiscalV32 = function (serie, folio, fecha, uuid) {
        var params = new http_1.URLSearchParams();
        params.set('serie', serie);
        params.set('folio', folio.toString());
        params.set('fecha', fecha);
        params.set('uuid', uuid);
        return this.apiService.getData('comprobante-fiscal-v32', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ComprobanteService.prototype.getComprativoComprobante = function (compania, fechaIni, fechaFin, tienePoliza, noTienePoliza, existeSiSatNoPixcua, existeNoSatSiPixcua, cancSiSatNoPixcua, cancNoSatSiPixcua, docEmitido, docRecibido, idBranch, request) {
        var params = new http_1.URLSearchParams();
        params.set('compania', compania);
        params.set('fechaIni', fechaIni);
        params.set('fechaFin', fechaFin);
        params.set('tienePoliza', tienePoliza.toString());
        params.set('noTienePoliza', noTienePoliza.toString());
        params.set('existeSiSatNoPixcua', existeSiSatNoPixcua.toString());
        params.set('existeNoSatSiPixcua', existeNoSatSiPixcua.toString());
        params.set('cancSiSatNoPixcua', cancSiSatNoPixcua.toString());
        params.set('cancNoSatSiPixcua', cancNoSatSiPixcua.toString());
        params.set('docEmitido', docEmitido.toString());
        params.set('docRecibido', docRecibido.toString());
        params.set('idBranch', idBranch.toString());
        return this.apiService.postData('comparativo-comprobante-fiscal', params, request)
            .map(function (response) {
            return response.json();
        })
            .toPromise();
    };
    ComprobanteService.prototype.getProgramacionComparativo = function (idProgramacion) {
        var params = new http_1.URLSearchParams();
        params.set("idProgramacion", idProgramacion.toString());
        return this.apiService.getData('programacion-comparativo', params)
            .map(function (response) {
            return response.json();
        }).toPromise();
    };
    ComprobanteService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.Http, core_2.Context])
    ], ComprobanteService);
    return ComprobanteService;
}(core_2.BaseService));
exports.ComprobanteService = ComprobanteService;
