"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
require("rxjs/add/operator/toPromise");
//Azteca Kernel
var core_2 = require("framework3/core");
//Locales
var empresa_1 = require("../models/empresa");
var EmpresaService = /** @class */ (function (_super) {
    __extends(EmpresaService, _super);
    function EmpresaService(http, context) {
        return _super.call(this, http, context, "api/contabilidad/empresas") || this;
    }
    EmpresaService.prototype.create = function () {
        return Promise.resolve(new empresa_1.EmpresaInfo());
    };
    EmpresaService.prototype.getPeriodoActual = function (idEmpresa) {
        var params = new http_1.URLSearchParams();
        params.set('IdEmpresa', idEmpresa.toString());
        return this.apiService.getData('get-periodo-actual', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    EmpresaService.prototype.loadEjercicios = function (idEmpresa, soloAbiertos) {
        var params = new http_1.URLSearchParams();
        params.set('IdEmpresa', idEmpresa.toString());
        params.set('SoloAbiertos', soloAbiertos.toString());
        return this.apiService.getData('load-list-ejercicios', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    EmpresaService.prototype.nuevoEjercicio = function (idEmpresa) {
        var params = new http_1.URLSearchParams();
        params.set('IdEmpresa', idEmpresa.toString());
        return this.apiService.postData('nuevo-ejercicio', params, null)
            .toPromise();
    };
    EmpresaService.prototype.abrirEjercicio = function (idEjercicio) {
        var params = new http_1.URLSearchParams();
        params.set('IdEjercicio', idEjercicio.toString());
        return this.apiService.postData('abrir-ejercicio', params, null)
            .toPromise();
    };
    EmpresaService.prototype.cerrarEjercicio = function (idEjercicio) {
        var params = new http_1.URLSearchParams();
        params.set('IdEjercicio', idEjercicio.toString());
        return this.apiService.postData('cerrar-ejercicio', params, null)
            .toPromise();
    };
    EmpresaService.prototype.cargarPeriodos = function (idEjercicio, soloAbiertos) {
        var params = new http_1.URLSearchParams();
        params.set('IdEjercicio', idEjercicio.toString());
        params.set('SoloAbiertos', soloAbiertos.toString());
        return this.apiService.getData('cargar-periodos', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    EmpresaService.prototype.abrirPeriodo = function (idPeriodo) {
        var params = new http_1.URLSearchParams();
        params.set('IdPeriodo', idPeriodo.toString());
        return this.apiService.postData('abrir-periodo', params, null)
            .toPromise();
    };
    EmpresaService.prototype.cerrarPeriodo = function (idPeriodo) {
        var params = new http_1.URLSearchParams();
        params.set('IdPeriodo', idPeriodo.toString());
        return this.apiService.postData('cerrar-periodo', params, null)
            .toPromise();
    };
    EmpresaService.prototype.loadRegimenesFiscales = function (idEmpresa) {
        var params = new http_1.URLSearchParams();
        params.append("idEmpresa", idEmpresa.toString());
        return this.apiService.getData("load-regimenes-fiscales", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    EmpresaService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.Http, core_2.Context])
    ], EmpresaService);
    return EmpresaService;
}(core_2.CatalogService));
exports.EmpresaService = EmpresaService;
