"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
require("rxjs/add/operator/toPromise");
var moment = require("moment");
//Azteca Framework
var core_2 = require("framework3/core");
//Locales
var poliza_1 = require("../models/poliza");
var PolizaService = /** @class */ (function (_super) {
    __extends(PolizaService, _super);
    function PolizaService(http, context) {
        var _this = _super.call(this, http, context, 'api/contabilidad/polizas-tit') || this;
        _this.http = http;
        _this.context = context;
        return _this;
    }
    PolizaService.prototype.create = function () {
        var newDoc = new poliza_1.PolizaInfo();
        return Promise.resolve(newDoc);
    };
    PolizaService.prototype.marcarExportacion = function (idPolizaTit, status, mensaje) {
        var params = new http_1.URLSearchParams();
        params.set('idPolizaTit', idPolizaTit);
        params.set('status', status.toString());
        params.set('mensaje', mensaje.toString());
        return this.apiService.postData('marcar-exportacion', params, null)
            .toPromise();
    };
    PolizaService.prototype.loadLog = function (idPolizaTit) {
        var params = new http_1.URLSearchParams();
        params.append("idPolizaTit", idPolizaTit);
        return this.apiService.getData("load-log", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    PolizaService.prototype.loadAsociaciones = function (idPolizaTit) {
        var params = new http_1.URLSearchParams();
        params.append("idPolizaTit", idPolizaTit);
        return this.apiService.getData("load-asociaciones", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    PolizaService.prototype.loadPerfilesByLote = function (idEmpresa, idUsuario) {
        var params = new http_1.URLSearchParams();
        params.append("idEmpresa", idEmpresa.toString());
        params.append("idUsuario", idUsuario.toString());
        return this.apiService.getData("load-perfiles-by-lote", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    PolizaService.prototype.contabilizarByLote = function (idSucursal, idPerfil, fechaIni, fechaFin) {
        var params = new http_1.URLSearchParams();
        var fi = moment(fechaIni).format();
        var ff = moment(fechaFin).format();
        params.append("IdSucursal", idSucursal.toString());
        params.append("IdPerfil", idPerfil.toString());
        params.append("FechaIni", fi);
        params.append("FechaFin", ff);
        return this.apiService.getData("load-contabilizacion-by-lote", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    PolizaService.prototype.getPolizaByPerfil = function (idSucursal, idPerfil, fecha) {
        var params = new http_1.URLSearchParams();
        var f = moment(fecha).format();
        params.append("IdSucursal", idSucursal.toString());
        params.append("IdPerfil", idPerfil.toString());
        params.append("Fecha", f);
        return this.apiService.getData("get-poliza-by-perfil", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    PolizaService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.Http, core_2.Context])
    ], PolizaService);
    return PolizaService;
}(core_2.DocumentService));
exports.PolizaService = PolizaService;
