"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
require("rxjs/add/operator/toPromise");
var moment = require("moment");
//Azteca Kernel
var core_2 = require("framework3/core");
//Locales
var reporte_1 = require("../models/reporte");
var ReporteService = /** @class */ (function (_super) {
    __extends(ReporteService, _super);
    function ReporteService(http, context) {
        return _super.call(this, http, context, "api/credito/reportes") || this;
    }
    ReporteService.prototype.create = function () {
        return Promise.resolve(new reporte_1.ReporteInfo());
    };
    ReporteService.prototype.printAbonos = function (fechaIni, fechaFin, tipoAbono) {
        var params = new http_1.URLSearchParams();
        params.set('FechaIni', moment(fechaIni).format());
        params.set('FechaFin', moment(fechaFin).format());
        params.set('IdConcepto', tipoAbono.toString());
        return this.apiService.getData('print-abonos', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ReporteService.prototype.printAntiguedadSaldos = function (idSucursal, fechaIni, fechaFin, rango) {
        var params = new http_1.URLSearchParams();
        params.set('IdSucursal', idSucursal.toString());
        params.set('FechaIni', moment(fechaIni).format());
        params.set('FechaFin', moment(fechaFin).format());
        params.set('Lapso', rango.toString());
        return this.apiService.getData('print-antiguedad-saldos', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ReporteService.prototype.printAntiguedadSaldosDetallado = function (idSucursal, fechaIni, fechaFin, rango) {
        var params = new http_1.URLSearchParams();
        params.set('IdSucursal', idSucursal.toString());
        params.set('FechaIni', moment(fechaIni).format());
        params.set('FechaFin', moment(fechaFin).format());
        params.set('Lapso', rango.toString());
        return this.apiService.getData('print-antiguedad-saldos-detallado', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ReporteService.prototype.printCobranzaImpuestos = function (fechaIni, fechaFin) {
        var params = new http_1.URLSearchParams();
        params.set('FechaIni', moment(fechaIni).format());
        params.set('FechaFin', moment(fechaFin).format());
        return this.apiService.getData('print-cobranza-impuestos', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ReporteService.prototype.printComportamiento = function (fechaIni, fechaFin, cadenaTipo) {
        var params = new http_1.URLSearchParams();
        params.set('FechaIni', moment(fechaIni).format());
        params.set('FechaFin', moment(fechaFin).format());
        params.set('IdTipoCadena', cadenaTipo.toString());
        return this.apiService.getData('print-comportamiento', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ReporteService.prototype.printControlInventarioEfectoIEPS = function (fechaIni, fechaFin, aplicaIEPS) {
        var params = new http_1.URLSearchParams();
        params.set('FechaIni', moment(fechaIni).format());
        params.set('FechaFin', moment(fechaFin).format());
        params.set('AplicaIEPS', aplicaIEPS.toString());
        return this.apiService.getData('print-control-inventario-efecto-ieps', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ReporteService.prototype.printCreditosOtogados = function (fechaIni, fechaFin) {
        var params = new http_1.URLSearchParams();
        params.set('FechaIni', moment(fechaIni).format());
        params.set('FechaFin', moment(fechaFin).format());
        return this.apiService.getData('print-creditos-otorgados', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ReporteService.prototype.printEstructuraClientesCadenas = function (idRegion) {
        var params = new http_1.URLSearchParams();
        params.set('IdRegion', idRegion.toString());
        return this.apiService.getData('print-estructura-clientes-cadenas', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ReporteService.prototype.loadClasificacionesList = function () {
        var params = new http_1.URLSearchParams();
        return this.apiService.getData("load-clasificaciones-list", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ReporteService.prototype.printEstructuraClasificaciones = function (idClasificacion) {
        var params = new http_1.URLSearchParams();
        params.set('IdClasificacion', idClasificacion.toString());
        return this.apiService.getData('print-estructura-clasificaciones', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ReporteService.prototype.printFacturasCredito = function (fechaIni, fechaFin, idSucursal, ruta, cliente, cadena, activas) {
        var params = new http_1.URLSearchParams();
        params.set('FechaIni', moment(fechaIni).format());
        params.set('FechaFin', moment(fechaFin).format());
        params.set('IdSucursal', idSucursal.toString());
        params.set('Ruta', ruta);
        params.set('Cliente', cliente);
        params.set('Cadena', cadena);
        params.set('Activas', activas.toString());
        return this.apiService.getData('print-facturas-credito', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ReporteService.prototype.printHistoricoSaldos = function (fecha) {
        var params = new http_1.URLSearchParams();
        params.set('Fecha', moment(fecha).format());
        return this.apiService.getData('print-historico-saldos', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ReporteService.prototype.printSaldosCredito = function () {
        var params = new http_1.URLSearchParams();
        return this.apiService.getData('print-saldos-credito', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ReporteService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.Http, core_2.Context])
    ], ReporteService);
    return ReporteService;
}(core_2.CatalogService));
exports.ReporteService = ReporteService;
