"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
require("rxjs/add/operator/toPromise");
//Azteca Kernel
var core_2 = require("framework3/core");
var AlmacenService = /** @class */ (function (_super) {
    __extends(AlmacenService, _super);
    function AlmacenService(http, context) {
        return _super.call(this, http, context, "api/inventario/almacenes") || this;
    }
    AlmacenService.prototype.create = function () {
        return this.apiService.getData('create', null)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    AlmacenService.prototype.LoadAccessUsersList = function (idAlmacen) {
        var params = new http_1.URLSearchParams();
        params.append("idAlmacen", idAlmacen.toString());
        return this.apiService.getData("load-access-users-list", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    AlmacenService.prototype.addMembers = function (idAlmacen, usuarios) {
        var params = new http_1.URLSearchParams();
        params.set('idAlmacen', idAlmacen.toString());
        return this.apiService.postData('add-members', params, usuarios)
            .toPromise();
    };
    AlmacenService.prototype.updateMembers = function (idAlmacen, usuarios) {
        var params = new http_1.URLSearchParams();
        params.set('idAlmacen', idAlmacen.toString());
        return this.apiService.postData('update-members', params, usuarios)
            .toPromise();
    };
    AlmacenService.prototype.removeMember = function (idAlmacen, idUsuario) {
        var params = new http_1.URLSearchParams();
        params.set('idAlmacen', idAlmacen.toString());
        params.set('idUsuario', idUsuario.toString());
        return this.apiService.delete('remove-member', params)
            .toPromise();
    };
    AlmacenService.prototype.loadList = function (idArea) {
        var params = new http_1.URLSearchParams();
        params.append("idArea", idArea.toString());
        return this.apiService.getData("load-list", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    AlmacenService.prototype.loadListByUser = function (idArea, idUsuario) {
        var params = new http_1.URLSearchParams();
        params.append("idArea", idArea.toString());
        params.append("idUsuario", idArea.toString());
        return this.apiService.getData("load-list-by-user", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    //////ArticulosPermitidos////////
    AlmacenService.prototype.LoadClasificacionesArticulos = function () {
        var params = new http_1.URLSearchParams();
        return this.apiService.getData("load-clasificaciones-articulos", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    AlmacenService.prototype.LoadClasificacionesPermitidas = function (idAlmacen) {
        var params = new http_1.URLSearchParams();
        params.append("idAlmacen", idAlmacen.toString());
        return this.apiService.getData("load-clasificaciones-permitidas", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    AlmacenService.prototype.updateClasificacionesArticulos = function (idAlmacen, data) {
        var params = new http_1.URLSearchParams();
        params.set('idAlmacen', idAlmacen.toString());
        return this.apiService.postData('update-clasificaciones-articulos', params, data)
            .toPromise();
    };
    AlmacenService.prototype.removeClasificacionesArticulos = function (idAlmacen, idClasificacion) {
        var params = new http_1.URLSearchParams();
        params.set('idAlmacen', idAlmacen.toString());
        params.set('idClasificacion', idClasificacion.toString());
        return this.apiService.delete('remove-clasificaciones-articulos', params)
            .toPromise();
    };
    //////Existencias////////
    AlmacenService.prototype.loadExistencias = function (idAlmacen) {
        var params = new http_1.URLSearchParams();
        params.append("idAlmacen", idAlmacen.toString());
        return this.apiService.getData("load-existencias", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    AlmacenService.prototype.loadExistenciasbyArt = function (idArticuloStock, idSucursal) {
        var params = new http_1.URLSearchParams();
        params.append("idArticuloStock", idArticuloStock.toString());
        params.append("idSucursal", idSucursal.toString());
        return this.apiService.getData("load-existencias-by-article", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ////// STOCK ////////
    AlmacenService.prototype.loadStock = function (idAlmacen, idArticuloStock) {
        var params = new http_1.URLSearchParams();
        params.append("idAlmacen", idAlmacen.toString());
        params.append("idArticuloStock", idArticuloStock.toString());
        return this.apiService.getData("stock", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    AlmacenService.prototype.loadStockAlmacen = function (idAlmacen) {
        var params = new http_1.URLSearchParams();
        params.append("idAlmacen", idAlmacen.toString());
        return this.apiService.getData("stock-almacen", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    AlmacenService.prototype.loadStockArticulo = function (idArticulo, idSucursal) {
        var params = new http_1.URLSearchParams();
        params.append("idArticulo", idArticulo.toString());
        params.append("idSucursal", idSucursal.toString());
        return this.apiService.getData("stock-articulo", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    AlmacenService.prototype.updateStockByArticulo = function (idArticulo, data) {
        var params = new http_1.URLSearchParams();
        params.set('idArticulo', idArticulo.toString());
        return this.apiService.postData('update-stock-by-article', params, data)
            .toPromise();
    };
    AlmacenService.prototype.updateStock = function (idAlmacen, data) {
        var params = new http_1.URLSearchParams();
        params.set('idAlmacen', idAlmacen.toString());
        return this.apiService.postData('update-stock', params, data)
            .toPromise();
    };
    //Metodos del selector customizados
    AlmacenService.prototype.searchKeywordAlmacenes = function (idBranch, keyword) {
        var params = new http_1.URLSearchParams();
        params.set('idBranch', idBranch.toString());
        params.set('keyword', keyword);
        return this.apiService.getData('search-keyword', params)
            .map(function (response) { return response.json(); });
    };
    AlmacenService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.Http, core_2.Context])
    ], AlmacenService);
    return AlmacenService;
}(core_2.CatalogService));
exports.AlmacenService = AlmacenService;
