"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
require("rxjs/add/operator/toPromise");
var moment = require("moment");
//Azteca Kernel
var core_2 = require("framework3/core");
var ArticuloStockService = /** @class */ (function (_super) {
    __extends(ArticuloStockService, _super);
    function ArticuloStockService(http, context) {
        return _super.call(this, http, context, "api/inventory/articulos-stock") || this;
    }
    ArticuloStockService.prototype.create = function () {
        return this.apiService.getData('create', null)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ArticuloStockService.prototype.loadList = function () {
        var params = new http_1.URLSearchParams();
        return this.apiService.getData("load-list", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ArticuloStockService.prototype.loadFotografias = function (idArticuloStock) {
        var params = new http_1.URLSearchParams();
        params.set("idArticuloStock", idArticuloStock.toString());
        return this.apiService.getData("load-fotografias", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ArticuloStockService.prototype.agregarFotografia = function (idArticuloStock, articulosFotografia) {
        var params = new http_1.URLSearchParams();
        params.set("idArticuloStock", idArticuloStock.toString());
        return this.apiService.postData("agregar-fotografia", params, articulosFotografia)
            .toPromise();
    };
    ArticuloStockService.prototype.eliminarFotografia = function (idArticuloStock, idArchivo) {
        var params = new http_1.URLSearchParams();
        params.set("idArticuloStock", idArticuloStock.toString());
        params.set("idArchivo", idArchivo);
        return this.apiService.delete("eliminar-fotografia", params)
            .toPromise();
    };
    ArticuloStockService.prototype.loadExistenciasLote = function (idArticuloStock, idAlmacen) {
        var params = new http_1.URLSearchParams();
        params.set('idArticuloStock', idArticuloStock.toString());
        params.set('idAlmacen', idAlmacen.toString());
        return this.apiService.getData('existencia-lotes', params)
            .map(function (response) {
            var lotes = response.json();
            lotes.forEach(function (lote) {
                lote.fechaCaducidad = moment(lote.fechaCaducidad).toDate();
                lote.fechaIngreso = moment(lote.fechaIngreso).toDate();
                lote.fecha = moment(lote.fecha).toDate();
            });
            return lotes;
        })
            .toPromise();
    };
    ArticuloStockService.prototype.loadExistenciasSerie = function (idArticuloStock, idAlmacen) {
        var params = new http_1.URLSearchParams();
        params.set('idArticuloStock', idArticuloStock.toString());
        params.set('idAlmacen', idAlmacen.toString());
        return this.apiService.getData('existencia-serie', params)
            .map(function (response) {
            var series = response.json();
            series.forEach(function (serie) {
                serie.fechaCaducidad = moment(serie.fechaCaducidad).toDate();
                serie.fechaIngreso = moment(serie.fechaIngreso).toDate();
            });
            return series;
        })
            .toPromise();
    };
    ArticuloStockService.prototype.getSerieInfo = function (idArticuloStock, idAlmacen, numeroSerie) {
        var params = new http_1.URLSearchParams();
        params.set('idArticuloStock', idArticuloStock.toString());
        params.set('idAlmacen', idAlmacen.toString());
        params.set('numeroSerie', numeroSerie);
        return this.apiService.getData('serie', params)
            .map(function (response) {
            var serie = response.json();
            if (serie) {
                serie.fechaCaducidad = moment(serie.fechaCaducidad).toDate();
                serie.fechaIngreso = moment(serie.fechaIngreso).toDate();
            }
            return serie;
        })
            .toPromise();
    };
    ArticuloStockService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.Http, core_2.Context])
    ], ArticuloStockService);
    return ArticuloStockService;
}(core_2.CatalogService));
exports.ArticuloStockService = ArticuloStockService;
