"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
require("rxjs/add/operator/toPromise");
//Azteca Kernel
var core_2 = require("framework3/core");
var ArticuloService = /** @class */ (function (_super) {
    __extends(ArticuloService, _super);
    function ArticuloService(http, context) {
        return _super.call(this, http, context, 'api/ventas/articulos') || this;
    }
    ArticuloService.prototype.create = function () {
        return this.apiService.getData('create', null)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ArticuloService.prototype.GetArticuloStock = function (idSucursal, codigo) {
        var params = new http_1.URLSearchParams();
        params.append("idSucursal", idSucursal.toString());
        params.append("codigo", codigo);
        return this.apiService.getData("get-articulo-stock", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ArticuloService.prototype.articuloAsignadoCheck = function (idArticuloStock) {
        var params = new http_1.URLSearchParams();
        params.append("idArticuloStock", idArticuloStock.toString());
        return this.apiService.getData("articulo-asignado-check", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ArticuloService.prototype.getArticuloByArticuloStock = function (idArticuloStock) {
        var params = new http_1.URLSearchParams();
        params.append("idArticuloStock", idArticuloStock.toString());
        return this.apiService.getData("get-articulo-by-articulo-stock", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    //Lista de Precios
    ArticuloService.prototype.loadArticuloListaPrecios = function (idEmpresa, idArticulo) {
        var params = new http_1.URLSearchParams();
        params.append("idEmpresa", idEmpresa.toString());
        params.append("idArticulo", idArticulo.toString());
        return this.apiService.getData("load-articulo-lista-precios", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ArticuloService.prototype.updateArticuloListaPrecios = function (data, idArticulo) {
        var params = new http_1.URLSearchParams();
        params.append("idArticulo", idArticulo.toString());
        return this.apiService.postData('update-articulo-lista-precios', params, data)
            .toPromise();
    };
    //Grupos de Descuentos
    ArticuloService.prototype.loadArticuloGrupoDescuento = function (idEmpresa, idArticulo) {
        var params = new http_1.URLSearchParams();
        params.append("idEmpresa", idEmpresa.toString());
        params.append("idArticulo", idArticulo.toString());
        return this.apiService.getData("load-articulo-grupo-descuento", params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ArticuloService.prototype.updateArticuloGrupoDescuento = function (data, idArticulo) {
        var params = new http_1.URLSearchParams();
        params.append("idArticulo", idArticulo.toString());
        return this.apiService.postData('update-articulo-grupo-descuento', params, data)
            .toPromise();
    };
    ArticuloService.prototype.calcularPrecio = function (idArticulo, idListaPrecios, idGrupoDescuentos, idEmpresa) {
        var params = new http_1.URLSearchParams();
        params.append("idArticulo", idArticulo.toString());
        params.append("idListaPrecios", idListaPrecios.toString());
        params.append("idGrupoDescuentos", idGrupoDescuentos.toString());
        params.append("idEmpresa", idEmpresa.toString());
        return this.apiService.getData('precio', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ArticuloService.prototype.calcularPrecioCliente = function (idArticulo, idCliente, idEmpresa) {
        var params = new http_1.URLSearchParams();
        params.append("idArticulo", idArticulo.toString());
        params.append("idCliente", idCliente.toString());
        params.append("idEmpresa", idEmpresa.toString());
        return this.apiService.getData('precio-cliente', params)
            .map(function (response) { return response.json(); })
            .toPromise();
    };
    ArticuloService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [http_1.Http, core_2.Context])
    ], ArticuloService);
    return ArticuloService;
}(core_2.CatalogService));
exports.ArticuloService = ArticuloService;
