import { Http } from '@angular/http';
import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/toPromise';
import { Context, DocumentService, FileLink } from 'framework3/core';
import { VentaInfo, VentaItem } from '../models/venta';
import { VentaDetail } from '../models/venta-detail';
export declare class VentaService extends DocumentService<VentaDetail, VentaInfo> {
    protected http: Http;
    protected context: Context;
    constructor(http: Http, context: Context);
    create(): Promise<VentaInfo>;
    update(info: VentaInfo): Promise<VentaInfo>;
    searchKeyword(idBranch: number, keyword: string): Observable<VentaItem[]>;
    protected mapDocument(document: VentaInfo): void;
    generarPdfFactura(idVenta: string): Promise<FileLink>;
    getXmlFactura(idVenta: string): Promise<FileLink>;
    loadEstadisticaPeriodo(idSucursal: number, fechaInicial: Date, fechaFinal: Date): Promise<any[]>;
}
